<script>
  import { extent } from "d3-array";
  import { select } from "d3-selection";
  import { scaleLinear } from "d3-scale";
  import { axisBottom, axisLeft } from "d3-axis";
  import { brush, brushSelection } from "d3-brush";
  
  

  // Properties
  export let data = [];
  export let x = (d) => d.x;
  export let y = (d) => d.y;
  export let xLabel = "x";
  export let yLabel = "y";

  // Dimensions
  const width = 400;
  const height = 300;
  const margin = { top: 10, right: 10, bottom: 35, left: 45 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  // Scales
  const xScale = scaleLinear().domain(extent(data, x)).range([0, innerWidth]);
  const yScale = scaleLinear().domain(extent(data, y)).range([innerHeight, 0]);

  // Axes
  const xAxis = (node) => axisBottom(xScale)(select(node));
  const yAxis = (node) => axisLeft(yScale)(select(node));

  // Brushing
  // The range of the selection rectangle.
  // If there is no active selection, it contains: null,
  // otherwise, it contains: [ [x0, y0], [x1, y1] ]
  let range = null;

  function doStart(selection) {
    range = selection.selection;
  }

  function doMove(selection) {
    range = selection.selection;
  }

  function doEnd(selection) {
    range = selection.selection;
  }
  
  const brush_start = (node) => brush()
    .on('start', doStart)
    .on('brush', doMove)
    .on('end', doEnd)
    (select(node));

  export let points = new Array(data.length).fill(true);

  export let points2 = new Array(data.length).fill(true);

  let coords = [];

  function fillCoords(dataset) {
    for (let data of dataset) {
      let coord = {
        x:xScale(x(data)),
        y:yScale(y(data))
      };
      coords.push(coord);
    }
  }

  function filterData(selection, coord) {
    if (selection != null) {
      for (let i=0; i<coord.length; i++) {
        if (coord[i].x + margin.left > selection[0][0] && coord[i].x+margin.left < selection[1][0] && coord[i].y + margin.top > selection[0][1] && coord[i].y+margin.top < selection[1][1]){
          points2[i] = true;
        }else{
          points2[i] = false;
        }
      }
    }else if (selection == null) {
      for (let i=0; i<coord.length; i++) {
        points2[i] = true;
      }
    }
  }

  function Color(bool) {
    if (bool) {
      return "steelblue";
    }else{
      return "darkgray";
    }
  }

  function Opac(bool) {
    if (bool) {
      return "0.5";
    }else {
      return "0.3";
    }
  }

  function Opac2(bool) {
    if (bool) {
      return "1"
    }else{
      return "0.5";
    }
  }

  $: fillCoords(data);
  $: filterData(range, coords);
</script>

<svg viewBox="0 0 {width} {height}" class="mx-2" style="max-width: {width}px" use:brush_start>
  <g transform="translate({margin.left},{margin.top})">
    <g>
      {#each coords as coord, index}
        <circle
          cx={coord.x}
          cy={coord.y}
          r={3}
          fill={Color(points[index])}
          fill-opacity={Opac(points[index])}
          stroke={Color(points[index])}
          stroke-width="1.5"
          stroke-opacity={Opac2(points[index])}
        />
      {/each}
    </g>
    <g use:xAxis transform="translate(0, {innerHeight})">
      <text class="axisLabel" x={innerWidth / 2} y={margin.bottom - 5}
        >{xLabel}</text
      >
    </g>
    <g use:yAxis>
      <text
        class="axisLabel"
        y={-margin.left + 10}
        x={-innerHeight / 2}
        transform="rotate(-90)">{yLabel}</text
      >
    </g>
  </g>
</svg>

<style>
  .axisLabel {
    text-anchor: middle;
    vertical-align: bottom;
    fill: currentcolor;
  }
</style>
